/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { Base, String_$type, typeCast, enumGetBox, fromEnum, runOn, delegateCombine, delegateRemove, Date_$type, Point_$type, markType, markDep } from "igniteui-react-core";
import { Series } from "./Series";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CalloutCollisionMode_$type } from "./CalloutCollisionMode";
import { FontUtil } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { HashSet$1 } from "igniteui-react-core";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { List$1 } from "igniteui-react-core";
import { LinkedList$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { LinkedListNode$1 } from "igniteui-react-core";
import { LabelCollisionManager } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { CalloutAnnotation } from "./CalloutAnnotation";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { QuadTreeBoundingBox } from "igniteui-react-core";
import { LabelCollisionInfo } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Size } from "igniteui-react-core";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutKey } from "./CalloutKey";
import { DataContext } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { FastItemObjectColumn } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { DOMExecutionContext } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { CalloutViewHelper } from "./CalloutViewHelper";
import { Rectangle } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
/**
 * @hidden
 */
export let CalloutLayer = /*@__PURE__*/ (() => {
    class CalloutLayer extends AnnotationLayer {
        constructor() {
            super();
            this.calloutStyleUpdating = null;
            this.nf = null;
            this.ng = null;
            this.nh = null;
            this.ne = null;
            this.nd = null;
            this.n4 = new HashSet$1(CalloutAnnotationWrapper.$, 0);
            this.n7 = new List$1(CalloutAnnotationWrapper.$, 0);
            this.n8 = new List$1(CalloutAnnotationWrapper.$, 0);
            this.nb = null;
            this.n5 = new LinkedList$1(CalloutAnnotationWrapper.$);
            this.n2 = new Dictionary$2(CalloutAnnotationWrapper.$, LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
            this.nn = null;
            this.qx = new Rect(0, 0, 0, 1, 1);
            this.nu = false;
            this.oi = 0;
            this.qw = Rect.empty;
            this.ns = false;
            this.nt = false;
            this.calloutContentUpdating = null;
            this.calloutLabelUpdating = null;
            this.calloutSeriesSelecting = null;
            this.n6 = new List$1(SeriesPointOfInterest.$, 0);
            this.nw = false;
            this.nx = false;
            this.oa = 0;
            this.nv = false;
            this.nr = true;
            FastItemObjectColumn.m();
            this.ma = true;
            let a = new CalloutLayerFrame();
            let b = new CalloutLayerFrame();
            let c = new CalloutLayerFrame();
            let d = this.fi / 1000;
            this.l2 = a;
            this.l1 = b;
            this.l3 = c;
            this.ab = CalloutLayer.$;
        }
        pp(a, b) {
            this.n8.clear();
            this.jd(false);
        }
        hy(a, b, c, d) {
            super.hy(a, b, c, d);
            let e = this.n3();
            switch (a) {
                case 3:
                    this.p1(b, e);
                    break;
                case 1:
                    for (let f = b; f < b + c; f++) {
                        let g = new CalloutAnnotation();
                        let h = new CalloutAnnotationWrapper();
                        h.b = g;
                        h.b.series = this.na;
                        this.n8.insert(f, h);
                        this.p1(f, e);
                    }
                    break;
                case 0:
                    this.n8.v(b, c);
                    break;
                case 2:
                    for (let i = b; i < b + c; i++) {
                        this.p1(i, e);
                    }
                    break;
                case 4:
                    this.n8.clear();
                    for (let j = 0; j < this.bz.count; j++) {
                        let k = new CalloutAnnotation();
                        let l = new CalloutAnnotationWrapper();
                        l.b = k;
                        l.b.series = this.na;
                        this.n8.add(l);
                        this.p1(j, e);
                    }
                    break;
            }
            this.jd(true);
        }
        da(a) {
            return false;
        }
        n3() {
            let a = new Dictionary$2(String_$type, Series.$, 0);
            if (this.bs != null) {
                for (let b = 0; b < this.bs.series.count; b++) {
                    let c = this.bs.series._inner[b];
                    if (c.name != null && !a.containsKey(c.name)) {
                        a.addItem(c.name, c);
                    }
                }
            }
            return a;
        }
        p1(a, b) {
            if (this.nm == null || this.nk == null) {
                return;
            }
            let c = a;
            if (this.nl != null) {
                c = this.nl.item(a);
            }
            let d = this.nm.item(a);
            let e = this.nk.item(a);
            let f = this.n8._inner[a];
            if (this.nj != null) {
                f.b.key = this.nj.item(a);
            }
            if (this.n2.containsKey(f)) {
                f.b = this.n2.item(f).c.b;
            }
            f.b.xValue = c;
            f.b.yValue = d;
            f.b.text = e != null ? e.toString() : "";
            if (this.ni != null) {
                f.b.content = this.ni.item(a);
            }
            else {
                f.b.content = this.bz.item(a);
            }
            if (this.calloutSeriesSelecting != null) {
                let g = ((() => {
                    let $ret = new CalloutSeriesSelectingEventArgs();
                    $ret.c = c;
                    $ret.d = d;
                    $ret.item = this.bz.item(a);
                    return $ret;
                })());
                this.calloutSeriesSelecting(this, g);
                if (g.a != null) {
                    f.b.series = g.a;
                }
                else if (g.e != null) {
                    if (b.containsKey(g.e)) {
                        f.b.series = b.item(g.e);
                    }
                }
            }
            this.p2(f);
        }
        p2(a) {
            let b = new Thickness(0, 3);
            if (isNaN_(this.qz.c) || isNaN_(this.qz.e) || isNaN_(this.qz.d) || isNaN_(this.qz.b)) {
                b = new Thickness(0, 3);
            }
            else {
                b = this.qz;
            }
            let c = this.qs != null ? this.qs : this.m7.ce(a.b.series);
            let d = this.qv != null ? this.qv : this.m7.ch();
            let e = this.qu != null ? this.qu : this.m7.cg();
            let f = this.qt != null ? this.qt : this.m7.cf(a.b.series);
            let g = isNaN_(this.og) ? 0 : this.og;
            if (this.n0 && this.calloutStyleUpdating != null) {
                let h = new CalloutStyleUpdatingEventArgs();
                h.item = a.b.content;
                h.xValue = a.b.xValue;
                h.yValue = a.b.yValue;
                h.series = a.b.series;
                h.background = c;
                h.textColor = d;
                h.outline = e;
                h.leaderBrush = f;
                h.strokeThickness = g;
                this.calloutStyleUpdating(this, h);
                c = h.background;
                d = h.textColor;
                e = h.outline;
                f = h.leaderBrush;
                g = h.strokeThickness;
            }
            a.b.backgroundPadding = b;
            a.b.background = c;
            a.b.textColor = d;
            a.b.outline = e;
            a.b.leaderBrush = f;
            a.b.strokeThickness = g;
        }
        fs(a, b) {
            let c = this.gu(b);
            if (c == CalloutLayer.$$p[19]) {
                return this.ft(a, b, this.pd);
            }
            if (c == CalloutLayer.$$p[23]) {
                return this.ft(a, b, this.pk);
            }
            if (c == CalloutLayer.$$p[24]) {
                return this.ft(a, b, this.pn);
            }
            if (c == CalloutLayer.$$p[18]) {
                return this.ft(a, b, this.pa);
            }
            if (c == CalloutLayer.$$p[14]) {
                return this.ft(a, b, this.o4);
            }
            return super.fs(a, b);
        }
        get nk() {
            return this.nf;
        }
        set nk(a) {
            if (this.nf != a) {
                let b = this.nf;
                this.nf = a;
                this.raisePropertyChanged("LabelColumn", b, this.nf);
            }
        }
        get nl() {
            return this.ng;
        }
        set nl(a) {
            if (this.ng != a) {
                let b = this.ng;
                this.ng = a;
                this.raisePropertyChanged("XColumn", b, this.ng);
            }
        }
        get nm() {
            return this.nh;
        }
        set nm(a) {
            if (this.nh != a) {
                let b = this.nh;
                this.nh = a;
                this.raisePropertyChanged("YColumn", b, this.nh);
            }
        }
        get nj() {
            return this.ne;
        }
        set nj(a) {
            if (this.ne != a) {
                let b = this.ne;
                this.ne = a;
                this.raisePropertyChanged("KeyColumn", b, this.ne);
            }
        }
        get ni() {
            return this.nd;
        }
        set ni(a) {
            if (this.nd != a) {
                let b = this.nd;
                this.nd = a;
                this.raisePropertyChanged("ContentColumn", b, this.nd);
            }
        }
        pr(a, b) {
            if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
                let c = a.k;
                if (!this.n4.contains(c)) {
                    this.n4.add_1(c);
                    this.n7.add(c);
                    this.jd(false);
                }
            }
        }
        bf() {
            return new CalloutLayerView(this);
        }
        iu(a) {
            super.iu(a);
            this.m7 = a;
        }
        get qz() {
            return new Thickness(1, this.oc, this.oe, this.od, this.ob);
        }
        get nc() {
            if (this.nb == null) {
                this.nb = FontUtil.toFontInfo(this.e4, this.pg);
            }
            return this.nb;
        }
        ml(a, b) {
            if (this.na == null || this.na == a) {
                if (!this.aq.c) {
                    this.jd(b);
                }
            }
        }
        mn(a, b) {
            super.mn(a, b);
            let c = a;
            c.p.clear();
            c.q.clear();
            c.m.clear();
            c.f.clear();
            c.h.clear();
            c.g.clear();
            c.j.clear();
            c.l.clear();
            c.k.clear();
            c.i.clear();
            c.n.clear();
            c.o.clear();
            c.t.clear();
            c.u.clear();
            c.r.clear();
            c.s.clear();
            let d = this.n9();
            let e = new List$1(CalloutAnnotationWrapper.$, 0);
            if (this.ny) {
                if (this.l8(this.na)) {
                    this.py(this.na, c, e);
                }
                else {
                    for (let f of fromEnum(this.bs.series)) {
                        if (this.l8(f)) {
                            this.py(f, c, e);
                        }
                    }
                }
            }
            this.px(c, d, e);
        }
        jt(a, b) {
            super.jt(a, b);
            let c = b.width - this.qx.width;
            let d = b.height - this.qx.height;
            let e = 0;
            if (Math.abs(c) > Math.abs(d)) {
                e = c;
                this.oa = c * this.ly.width;
            }
            else {
                e = d;
                this.oa = d * this.ly.height;
            }
            if (e > 0 && this.oa > 5) {
                this.nx = true;
            }
            if (e < 0 && this.oa > 5) {
                this.nw = true;
            }
        }
        js(a, b) {
            super.js(a, b);
            if (!a.equals1(b)) {
                this.nv = true;
            }
        }
        get qy() {
            return this.qw;
        }
        set qy(a) {
            this.qw = a;
        }
        px(a, b, c) {
            if (this.bs != null) {
                this.qx = this.bs.mq;
            }
            if (this.ly.isEmpty) {
                return;
            }
            this.qy = new Rect(0, this.ly.left, this.ly.top, this.ly.width, this.ly.height);
            if (this.nn != null && this.o1 != null && this.o1 != this.nn.ak) {
                this.pt();
            }
            if (this.nn == null) {
                let d = this.no();
                if (d != null) {
                    this.nn = d;
                    let e = this.nn;
                    e.labelsMoved = delegateCombine(e.labelsMoved, runOn(this, this.pq));
                }
                else {
                    let f = this.lq(this.bi);
                    let g = 0;
                    if (this.na != null) {
                        if (this.na.isVertical) {
                            g = 2;
                        }
                    }
                    else {
                        let h = false;
                        if (this.bs != null && this.bs.series.count > 0) {
                            h = true;
                            for (let i of fromEnum(this.bs.series)) {
                                if (!i.cj) {
                                    if (!i.isVertical) {
                                        h = false;
                                    }
                                }
                            }
                        }
                        if (h) {
                            g = 2;
                        }
                    }
                    this.nn = new LabelCollisionManager(this.ly.right, this.ly.bottom, this.ly, this.m7.b4(), this.of, this.np(), g, this.om(), this.ol(), this.nz);
                    if (this.o1 != null) {
                        this.nn.ak = this.o1;
                        this.nn.ai = this;
                    }
                    let j = this.nn;
                    j.labelsMoved = delegateCombine(j.labelsMoved, runOn(this, this.pq));
                }
            }
            if (this.nw) {
                this.nw = false;
                if (this.nn.ag > 2) {
                    this.nu = true;
                }
            }
            if (this.nx) {
                this.nx = false;
                if (this.oa > 5) {
                    this.nu = true;
                }
            }
            if (this.nv) {
                this.nv = false;
                this.nn.ay(this.ly.right, this.ly.bottom, this.ly);
                this.nu = true;
            }
            let k = new HashSet$1(CalloutAnnotationWrapper.$, 0);
            let l = new HashSet$1(CalloutAnnotationWrapper.$, 0);
            let m = new List$1(CalloutAnnotationWrapper.$, 0);
            let n = new List$1(CalloutAnnotationWrapper.$, 0);
            let o = new HashSet$1(CalloutAnnotationWrapper.$, 0);
            for (let p = 0; p < b.count; p++) {
                o.add_1(b._inner[p]);
            }
            for (let q = 0; q < c.count; q++) {
                o.add_1(c._inner[q]);
            }
            let r = this.n5.c;
            while (r != null) {
                let s = r.a;
                if (!o.contains(r.c)) {
                    n.add(r.c);
                    l.add_1(r.c);
                    let t = r.c.b;
                    t.propertyChanged = delegateRemove(t.propertyChanged, runOn(this, this.pr));
                    this.n5.h(r);
                    this.n2.removeItem(r.c);
                    this.nn.ax(r.c.c);
                }
                r = s;
            }
            for (let u = 0; u < b.count; u++) {
                if (!this.n2.containsKey(b._inner[u])) {
                    this.n5.f(b._inner[u]);
                    let v = b._inner[u].b;
                    v.propertyChanged = delegateCombine(v.propertyChanged, runOn(this, this.pr));
                    this.n2.addItem(b._inner[u], this.n5.d);
                    m.add(b._inner[u]);
                    k.add_1(b._inner[u]);
                    this.nu = true;
                }
            }
            for (let w = 0; w < c.count; w++) {
                if (!this.n2.containsKey(c._inner[w])) {
                    this.n5.f(c._inner[w]);
                    this.n2.addItem(c._inner[w], this.n5.d);
                    let x = c._inner[w].b;
                    x.propertyChanged = delegateCombine(x.propertyChanged, runOn(this, this.pr));
                    m.add(c._inner[w]);
                    k.add_1(c._inner[w]);
                    this.nu = true;
                }
            }
            if (this.ns == true) {
                this.ns = false;
                this.nu = true;
            }
            if (this.n7.count > 0) {
                this.nu = true;
                this.n7.clear();
                this.n4.clear();
            }
            r = this.n5.c;
            while (r != null) {
                let y = this.nq(r.c);
                if (y == null) {
                    return;
                }
                if (!Base.equalsStatic(y, r.c.c.c)) {
                    let z = false;
                    if (r.c.c.c == null) {
                        z = true;
                    }
                    let aa = r.c.c;
                    aa.o = y.b;
                    aa.p = y.c;
                    if (!isNaN_(aa.o) && !isNaN_(aa.p)) {
                        aa.n = y.e;
                        aa.m = y.d;
                        if (aa.b == null) {
                            this.nn.p(aa);
                        }
                        if (z) {
                            this.nn.al(aa);
                        }
                        else {
                            this.nn.au(aa);
                        }
                    }
                }
                r = r.a;
            }
            let ab = this.nn.ah();
            let ac = this.nn.q();
            if (this.nu && (ab != 0 || ac)) {
                this.nu = false;
                this.oi = 0x7FFFFFFF;
                if (this.o1 != null) {
                    let ad = true;
                    for (let ae = 0; ae < this.bs.series.count; ae++) {
                        let af = this.bs.series._inner[ae];
                        if (af.cj && typeCast(CalloutLayer.$, af) !== null) {
                            let ag = af;
                            if (ag.o1 == this.o1) {
                                if (!ag.qy.equals1(this.nn.a0)) {
                                    ad = false;
                                    break;
                                }
                            }
                        }
                    }
                    if (ad) {
                        this.nn.az();
                    }
                    else {
                        this.nn.am();
                        this.nn.an();
                    }
                }
                else {
                    this.nn.az();
                }
            }
            else {
                this.nn.an();
            }
            let ah = this.n5.c;
            while (ah != null) {
                let ai = ah.c;
                a.m.add1(ai);
                a.f.add(ai.b.background);
                a.h.add(ai.b.outline);
                a.g.add(ai.b.leaderBrush);
                a.j.add(ai.b.backgroundPadding.c);
                a.l.add(ai.b.backgroundPadding.e);
                a.k.add(ai.b.backgroundPadding.d);
                a.i.add(ai.b.backgroundPadding.b);
                a.n.add(ai.b.strokeThickness);
                a.o.add(ai.b.textColor);
                a.p.add1(ai.b.text);
                a.q.add1(ai.b.content);
                let aj = ai.c;
                a.t.add(ai.c.o - (ai.c.g - ai.c.l));
                a.u.add(ai.c.p - (ai.c.h - ai.c.k));
                a.r.add(ai.c.g - ai.c.l);
                a.s.add(ai.c.h - ai.c.k);
                ah = ah.a;
            }
        }
        pt() {
            if (this.nn != null) {
                let a = this.n5.c;
                while (a != null) {
                    let b = a.c.c;
                    if (b != null) {
                        this.nn.ax(b);
                    }
                    a = a.a;
                }
                let c = this.nn;
                c.labelsMoved = delegateRemove(c.labelsMoved, runOn(this, this.pq));
                this.nn = null;
            }
            this.ps();
        }
        no() {
            if (this.bs == null) {
                return null;
            }
            for (let a = 0; a < this.bs.series.count; a++) {
                let b = this.bs.series._inner[a];
                if (b.cj && typeCast(CalloutLayer.$, b) !== null) {
                    let c = b;
                    if (c != this) {
                        if (c.o1 != null && c.o1 == this.o1) {
                            if (c.nn != null) {
                                return c.nn;
                            }
                        }
                    }
                }
            }
            return null;
        }
        ol() {
            return 20000;
        }
        om() {
            return 300;
        }
        np() {
            switch (this.m4) {
                case 0: return 2;
                case 2: return 1;
                case 3: return 2;
                case 1: return 0;
            }
            return 2;
        }
        pq(a) {
            let b = this.nn.ah();
            if (b < this.oi) {
                this.oi = b;
                this.jd(false);
            }
        }
        nq(a) {
            let b = this.na;
            if (a.b.series != null) {
                b = a.b.series;
            }
            if (b == null) {
                for (let c = 0; c < this.bs.series.count; c++) {
                    let d = this.bs.series._inner[c];
                    if (!d.cj) {
                        b = d;
                        break;
                    }
                }
            }
            if (b == null) {
                return null;
            }
            let e = b.ag();
            let f = b.eh();
            let g = null;
            let h = null;
            for (let i = 0; i < e.length; i++) {
                if (e[i].cf) {
                    h = e[i];
                }
                else {
                    g = e[i];
                }
            }
            if (g == null || h == null) {
                return null;
            }
            if (!g.ce() || !h.ce()) {
                return null;
            }
            let j = 0;
            let k = 0;
            if (g.b2 && g.categoryMode != 0) {
                if (b.cr) {
                    j = b.getOffsetValue();
                }
                else if (b.cl) {
                    j = b.getOffsetValue();
                }
            }
            if (h.b2 && h.categoryMode != 0) {
                if (b.cl) {
                    k = b.getOffsetValue();
                }
            }
            let l = new ScalerParams(0, this.bs.mq, g.i1, g.b8, g.iw());
            l.b = f;
            let m = new ScalerParams(0, this.bs.mq, h.i1, h.b8, h.iw());
            m.b = f;
            let n = g.dw(this.oh(a.b.xValue), l) + j;
            let o = h.dw(this.oh(a.b.yValue), m) + k;
            let p = new QuadTreeBoundingBox();
            p.b = n;
            p.c = o;
            p.e = 3;
            p.d = 3;
            p.g = a.b;
            return p;
        }
        oh(a) {
            if (typeCast(Date_$type, a) !== null) {
                return a.getTime();
            }
            if (a == null) {
                return 0;
            }
            return a;
        }
        n9() {
            let a = new List$1(CalloutAnnotationWrapper.$, 0);
            for (let b = 0; b < this.n8.count; b++) {
                if (stringIsNullOrEmpty(this.n8._inner[b].b.text)) {
                    continue;
                }
                if (this.n8._inner[b].c == null) {
                    let c = new LabelCollisionInfo();
                    this.n8._inner[b].c = c;
                    let d = this.m7.cj(this.on(this.n8._inner[b]), this.n8._inner[b].b.backgroundPadding);
                    c.k = d.height / 2;
                    c.l = d.width / 2;
                }
                let e = this.nq(this.n8._inner[b]);
                if (e == null || e.b < this.ly.left || e.b > this.ly.right || e.c < this.ly.top || e.c > this.ly.bottom) {
                    continue;
                }
                a.add(this.n8._inner[b]);
            }
            return a;
        }
        on(a) {
            return a.b.text;
        }
        l8(a) {
            if (!super.l8(a)) {
                return false;
            }
            return true;
        }
        io() {
            super.io();
            if (!this.aq.c && !this.ca()) {
                return;
            }
            if (this.nr) {
                this.nr = false;
                this.pv();
            }
            if (this.ca()) {
                this.p0(this.l3, false);
            }
            else {
                this.p0(this.l1, false);
            }
        }
        pw() {
            if (!this.nt) {
                this.nt = true;
                this.jd(true);
            }
        }
        py(a, b, c) {
            if (a.ch(this.n6, this.n1, this.oj)) {
                let d = this.n6;
                for (let e = 0; e < this.n6.count; e++) {
                    let f = d._inner[e];
                    let g = f.a.item != null ? f.a.item : f.a;
                    let h = a;
                    let i = new CalloutKey(g, h);
                    let j = new CalloutAnnotationWrapper();
                    let k = new CalloutAnnotation();
                    j.b = k;
                    k.key = i;
                    let l = false;
                    let m = false;
                    if (this.nt) {
                        this.nt = false;
                        m = true;
                    }
                    if (this.n2.containsKey(j)) {
                        j = this.n2.item(j).c;
                        k = j.b;
                    }
                    else {
                        if (!m) {
                            l = true;
                        }
                    }
                    let n = k.xValue;
                    let o = k.yValue;
                    if (this.oh(n) != this.oh(f.b)) {
                        k.xValue = f.b;
                    }
                    if (this.oh(o) != this.oh(f.c)) {
                        k.yValue = f.c;
                    }
                    k.series = a;
                    if (l && this.calloutLabelUpdating != null) {
                        let p = ((() => {
                            let $ret = new CalloutLabelUpdatingEventArgs();
                            $ret.c = k.xValue;
                            $ret.d = k.yValue;
                            $ret.item = g;
                            return $ret;
                        })());
                        this.calloutLabelUpdating(this, p);
                        if (p.b != null && !Base.equalsStatic(p.b, j.b.text)) {
                            let q = p.b;
                            j.b.text = q != null ? q.toString() : "";
                        }
                    }
                    else {
                        if (f.d != null) {
                            k.text = f.d;
                        }
                    }
                    if (k.text == null) {
                        continue;
                    }
                    if (l) {
                        if (this.calloutContentUpdating != null) {
                            let r = ((() => {
                                let $ret = new CalloutContentUpdatingEventArgs();
                                $ret.c = k.xValue;
                                $ret.d = k.yValue;
                                $ret.item = g;
                                $ret.a = g;
                                return $ret;
                            })());
                            this.calloutContentUpdating(this, r);
                            if (r.a != null && r.a != j.b.content) {
                                j.b.content = r.a;
                            }
                        }
                        else {
                            if (g != null && g != j.b.content) {
                                j.b.content = g;
                            }
                        }
                    }
                    if (l) {
                        this.p2(j);
                    }
                    if (j.c == null) {
                        let s = new LabelCollisionInfo();
                        j.c = s;
                        let t = this.m7.cj(this.on(j), j.b.backgroundPadding);
                        s.k = t.height / 2;
                        s.l = t.width / 2;
                    }
                    let u = this.nq(j);
                    if (u == null || u.b < this.ly.left || u.b > this.ly.right || u.c < this.ly.top || u.c > this.ly.bottom) {
                        continue;
                    }
                    c.add(j);
                }
            }
        }
        bd() {
            return 1;
        }
        ar(a, b) {
            let c = this.nn.d(a, b);
            if (c == null) {
                return null;
            }
            return c.u;
        }
        dh(a, b) {
            if (this.nn == null) {
                return false;
            }
            return this.nn.d(a, b) != null;
        }
        p0(a, b) {
            let c = 0;
            let d = new HashSet$1(CalloutAnnotationWrapper.$, 0);
            for (c = 0; c < a.p.count; c++) {
                let e = a.m._inner[c];
                if (isNaN_(a.t._inner[c]) || isNaN_(a.u._inner[c])) {
                    continue;
                }
                let f = this.m7.b6.item(e);
                d.add_1(e);
                if (f.f != a.p._inner[c]) {
                    f.f = a.p._inner[c];
                    let g = f.s();
                }
                f.c = a.n._inner[c];
                f.k = a.f._inner[c];
                f.n = a.o._inner[c];
                f.m = f.c > 0 ? a.h._inner[c] : this.bi.bn();
                f.l = a.g._inner[c];
                f.v = new Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
                this.m7.cc(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
                this.m7.cd(f, e, a.q._inner[c]);
                f.p = { $type: Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
            }
            let h = new List$1(CalloutAnnotationWrapper.$, 0);
            for (let i of fromEnum(this.m7.b6.c)) {
                if (!d.contains(i)) {
                    h.add(i);
                }
            }
            for (let j = 0; j < h.count; j++) {
                this.m7.b6.g(h._inner[j]);
            }
        }
        mq(a, b) {
            super.mq(a, b);
            if (this.ca()) {
                this.p0(this.l3, true);
            }
            else {
                this.p0(this.l1, false);
            }
        }
        c8() {
            return true;
        }
        iz(a, b, c, d) {
            super.iz(a, b, c, d);
            switch (b) {
                case CalloutLayer.$$p[21]:
                    this.nb = null;
                    this.jd(true);
                    break;
                case CalloutLayer.$$p[20]:
                    this.jd(true);
                    break;
                case CalloutLayer.$$p[13]:
                    this.jd(true);
                    break;
                case "SeriesViewer":
                    if (c != null) {
                        let e = c;
                        e.seriesAnimating = delegateRemove(e.seriesAnimating, runOn(this, this.pz));
                    }
                    if (d != null) {
                        let f = d;
                        f.seriesAnimating = delegateCombine(f.seriesAnimating, runOn(this, this.pz));
                    }
                    if (d == null) {
                        this.pt();
                    }
                    break;
                case CalloutLayer.$$p[15]:
                case CalloutLayer.$$p[16]:
                case CalloutLayer.$$p[1]:
                case CalloutLayer.$$p[5]:
                case CalloutLayer.$$p[4]:
                case CalloutLayer.$$p[7]:
                case CalloutLayer.$$p[9]:
                case CalloutLayer.$$p[8]:
                case CalloutLayer.$$p[6]:
                case CalloutLayer.$$p[11]:
                case CalloutLayer.$$p[12]:
                    this.pu();
                    break;
                case CalloutLayer.$$p[19]:
                    if (this.bz != null) {
                        this.bz.deregisterColumn(this.nk);
                        this.nk = this.by(this.pd);
                    }
                    break;
                case "LabelColumn":
                    this.pu();
                    break;
                case CalloutLayer.$$p[14]:
                    if (this.bz != null) {
                        this.bz.deregisterColumn(this.ni);
                        this.ni = this.by(this.o4);
                    }
                    break;
                case "ContentColumn":
                    this.pu();
                    break;
                case CalloutLayer.$$p[23]:
                    if (this.bz != null) {
                        this.bz.deregisterColumn(this.nl);
                        this.nl = stringIsNullOrEmpty(this.pk) == false ? this.by(this.pk) : null;
                    }
                    break;
                case "XColumn":
                    this.pu();
                    break;
                case CalloutLayer.$$p[24]:
                    if (this.bz != null) {
                        this.bz.deregisterColumn(this.nm);
                        this.nm = this.by(this.pn);
                    }
                    break;
                case "YColumn":
                    this.pu();
                    break;
                case CalloutLayer.$$p[18]:
                    if (this.bz != null) {
                        this.bz.deregisterColumn(this.nj);
                        this.nj = this.by(this.pa);
                    }
                    break;
                case "KeyColumn":
                    this.pu();
                    break;
                case "FastItemsSource":
                    this.ns = true;
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.nk);
                        c.deregisterColumn(this.ni);
                        c.deregisterColumn(this.nl);
                        c.deregisterColumn(this.nm);
                        c.deregisterColumn(this.nj);
                        this.nk = null;
                        this.ni = null;
                        this.nl = null;
                        this.nm = null;
                        this.nj = null;
                        this.n8.clear();
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.nk = this.by(this.pd);
                        this.ni = this.by(this.o4);
                        if (stringIsNullOrEmpty(this.pk) == false) {
                            this.nl = this.by(this.pk);
                        }
                        this.nm = this.by(this.pn);
                        this.nj = this.by(this.pa);
                    }
                    this.pu();
                    break;
            }
        }
        pz(a) {
            if (a.cj) {
                return;
            }
            if ((a == this.na || this.na == null) && this.ny) {
                this.jd(false);
            }
        }
        pu() {
            if (this.nr == false) {
                this.nr = true;
                this.jd(false);
            }
        }
        ps() {
            this.m7.b6.clear();
            this.n5.g();
            this.n2.clear();
        }
        pv() {
            if (this.nm == null || this.nk == null) {
                let a = this.n5.c;
                while (a != null) {
                    this.p2(a.c);
                    a = a.a;
                }
                return;
            }
            let b = this.n3();
            for (let c = 0; c < this.nm.count; c++) {
                let d;
                if (this.n8.count <= c) {
                    let e = new CalloutAnnotation();
                    d = new CalloutAnnotationWrapper();
                    d.b = e;
                    d.b.series = this.na;
                    this.n8.add(d);
                }
                else {
                    d = this.n8._inner[c];
                }
                this.p1(c, b);
            }
        }
    }
    CalloutLayer.$t = /*@__PURE__*/ markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
    CalloutLayer.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:oj:p3', [1, 5], 'CalloutBackground:qs:p4', [Brush.$, null], 'CalloutCollisionMode:m4:p5', [CalloutCollisionMode_$type, /*@__PURE__*/ enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:ok:p6', [1, -1], 'CalloutLeaderBrush:qt:p7', [Brush.$, null], 'CalloutOutline:qu:p8', [Brush.$, null], 'CalloutPaddingBottom:ob:p9', [1, NaN], 'CalloutPaddingLeft:oc:qa', [1, NaN], 'CalloutPaddingRight:od:qb', [1, NaN], 'CalloutPaddingTop:oe:qc', [1, NaN], 'CalloutPositionPadding:of:qd', [1, 10], 'CalloutStrokeThickness:og:qe', [1, NaN], 'CalloutTextColor:qv:qf', [Brush.$, null], 'CollisionChannel:o1:qg', [2, null], 'ContentMemberPath:o4:qh', [2, null], 'IsAutoCalloutBehaviorEnabled:ny:qi', [0, false], 'IsCalloutOffsettingEnabled:nz:qj', [0, true], 'IsCustomCalloutStyleEnabled:n0:qk', [0, false], 'KeyMemberPath:pa:ql', [2, null], 'LabelMemberPath:pd:qm', [2, null], 'TargetSeries:na:qn', [Series.$, null], 'TextStyle:pg:qo', [2, null], 'UseValueForAutoCalloutLabels:n1:qp', [0, true], 'XMemberPath:pk:qq', [2, null], 'YMemberPath:pn:qr', [2, null]]);
    return CalloutLayer;
})();
/**
 * @hidden
 */
export let CalloutLayerView = /*@__PURE__*/ (() => {
    class CalloutLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b1 = null;
            this.b7 = null;
            this.b6 = null;
            this.b8 = NaN;
            this.b2 = null;
            this.b1 = a;
            this.b7 = new List$1(CalloutView.$, 0);
        }
        ap() {
            super.ap();
            this.b6 = ((() => {
                let $ret = new HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
                $ret.create = runOn(this, this.b3);
                $ret.activate = runOn(this, this.b9);
                $ret.disactivate = runOn(this, this.cb);
                $ret.destroy = runOn(this, this.ca);
                return $ret;
            })());
        }
        b3() {
            let a = new CalloutView(this);
            this.b7.add(a);
            return a;
        }
        b9(a) {
            a.w = 0;
        }
        cb(a) {
            a.w = 1;
        }
        ca(a) {
            this.b7.remove(a);
        }
        ci(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.l(a, 0.1);
        }
        a3(a, b) {
            super.a3(a, b);
            a.ac(this.b5());
            if (a.d && !b) {
                for (let c = 0; c < this.b7.count; c++) {
                    let d = this.b7._inner[c];
                    if (d.w == 0) {
                        d.h(a);
                    }
                }
            }
        }
        b5() {
            if (this.b1.nc != null) {
                return this.b1.nc;
            }
            return this.e.bs.getFontInfo();
        }
        ai(a) {
            super.ai(a);
            for (let b = 0; b < this.b7.count; b++) {
                let c = this.b7._inner[b];
                if (c.w != 0) {
                    continue;
                }
                c.g(this.b1, this.b5(), a);
            }
        }
        ck(a) {
            if (isNaN_(this.b8)) {
                this.b8 = this.e.bs.bn.a7;
            }
            return new Size(1, this.h.f(a.ak), this.b8);
        }
        cj(a, b) {
            if (this.b2 == null) {
                this.b2 = new CalloutView(this);
            }
            this.b2.f = a;
            this.b2.v = b;
            let c = this.b2.s();
            this.b2.f = null;
            return c;
        }
        b4() {
            return new DOMExecutionContext(this.e.bs.bn.i.ae);
        }
        cc(a, b, c) {
            a.d = b;
            a.e = c;
        }
        cd(a, b, c) {
            a.i(this.e, b, c);
        }
        ce(a) {
            if (a != null) {
                return this.ci(a.k3);
            }
            return this.e.k3;
        }
        ch() {
            return ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(255, 255, 255, 255);
                return $ret;
            })());
        }
        cg() {
            return ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(255, 255, 255, 255);
                return $ret;
            })());
        }
        cf(a) {
            if (a != null) {
                return this.ci(a.k3);
            }
            return this.e.k3;
        }
    }
    CalloutLayerView.$t = /*@__PURE__*/ markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
    return CalloutLayerView;
})();
/**
 * @hidden
 */
export let CalloutView = /*@__PURE__*/ (() => {
    class CalloutView extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.w = 0;
            this.j = null;
            this.r = null;
            this.o = { $type: Point_$type, x: 0, y: 0 };
            this.q = null;
            this.u = new Thickness(0, 0);
            this.t = null;
            this.d = 0;
            this.e = 0;
            this.b = null;
            this.q = new Line();
            this.q.ab = false;
            this.q._stroke = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(255, 0, 0, 0);
                return $ret;
            })());
            this.q.ac = 2;
            this.j = new TextBlock();
            this.r = new Rectangle();
            this.r.ac = 0;
            this.a = a;
            this.w = 0;
        }
        h(a) {
            a.z();
            a.af(this.d, this.e);
            let b = new TranslateTransform();
            b.j = this.t.c;
            b.k = this.t.e;
            this.r.j = b;
            a.r(this.q);
            a.z();
            this.r.width = this.j.m + this.u.c + this.u.d;
            this.r.height = this.j.l + this.u.e + this.u.b;
            a.j(this.r.j);
            a.v(this.r);
            this.j.o = this.u.e;
            this.j.n = this.u.c;
            a.w(this.j);
            a.y();
            a.y();
        }
        get p() {
            return this.o;
        }
        set p(a) {
            if (this.o.x != a.x || this.o.y != a.y) {
                let b = this.s();
                let c = b.height;
                let d = b.width;
                this.o = a;
                let e = CalloutViewHelper.b(this.p, d, c, this.q);
                this.t = e;
            }
        }
        get n() {
            return this.j.am;
        }
        set n(a) {
            this.j.am = a;
        }
        get m() {
            return this.r._stroke;
        }
        set m(a) {
            this.r._stroke = a;
        }
        get l() {
            return this.q._stroke;
        }
        set l(a) {
            this.q._stroke = a;
        }
        get k() {
            return this.r._fill;
        }
        set k(a) {
            this.r._fill = a;
        }
        get c() {
            return this.r.ac;
        }
        set c(a) {
            this.r.ac = a;
        }
        get v() {
            return this.u;
        }
        set v(a) {
            this.u = a;
        }
        get f() {
            return this.j.ak;
        }
        set f(a) {
            if (a == null) {
                this.j.ak = "";
            }
            else {
                this.j.ak = a.toString();
            }
            let b = this.s();
            let c = b.height;
            let d = b.width;
            let e = CalloutViewHelper.b(this.p, d, c, this.q);
            this.t = e;
        }
        s() {
            let a = this.a.ck(this.j);
            this.j.m = a.width;
            this.j.l = a.height;
            return new Size(1, a.width + this.u.c + this.u.d, a.height + this.u.e + this.u.b);
        }
        i(a, b, c) {
            if (this.b == null) {
                this.b = new DataContext();
            }
            this.b.series = a;
            this.b.item = c;
            if (b.c != null) {
                b.c.u = this.b;
            }
        }
        g(a, b, c) {
            a.a2.exportCalloutData(this.d, this.e, this.t.c, this.t.e, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
        }
    }
    CalloutView.$t = /*@__PURE__*/ markType(CalloutView, 'CalloutView');
    return CalloutView;
})();
//# sourceMappingURL=CalloutLayer_combined.js.map
